
#include <stdio.h>
#include <stdlib.h>
#include "..\..\..\bmp.h"
#include "..\..\..\j2k-codec.h"

void main(int ArgC, char **ArgV)
{
 char Key[] = "Your registration key";

 if(ArgC<2){ printf("\n Please, specify the J2K file name!\n\n"); system("pause"); return; }


 // Get the DLL version and make sure it is at least 1.0

 int j2k_ver = J2K_getVersion(); if(j2k_ver < 0x100000) return;


 // Remove the demo version restrictions

 J2K_Unlock(Key); 


 // Open file, parse header and get image info

 J2K_Image j2k_image;

 int j2k_err = j2k_image.open(ArgV[1]); 
 if(j2k_err!=J2KERR_SUCCESS){ printf("\n  File '%s' opening error: %s.\n", ArgV[1], j2k_image.errStr); return; }

 printf("\n Image info: %ux%u, %u component(s).\n", j2k_image.width, j2k_image.height, j2k_image.components);


 // Let's allocate the buffer ourselves

 int bpp = (j2k_image.components==1) ? 1 : 4;

 j2k_image.pitch = j2k_image.width * bpp; 
 j2k_image.size  = j2k_image.pitch * j2k_image.height * bpp;

 j2k_image.buffer = new unsigned char[j2k_image.size];
 if(!j2k_image.buffer){ printf("\n Couldn't allocate %d bytes!\n", j2k_image.size); return; }


 // Prepare the options string

 char options[30]; sprintf(options, "bpp=%d", bpp); 


 // Decode the image with the correct bpp

 j2k_err = j2k_image.decode(options); 
 if(j2k_err!=J2KERR_SUCCESS) printf("\n Decoding error: %s.\n", j2k_image.errStr); 
 else
 {
  // Finally save the decoded image as BMP file

  SaveAsBMP("decoded.bmp", j2k_image.buffer, j2k_image.width, j2k_image.height, bpp);

  // It's our responsibility to delete the buffer, since we have allocated it
  delete j2k_image.buffer; 

  printf("\n Done!\n");
 }

 j2k_image.close(); //Optional, it will be called from the destructor anyway

}
